<?php


/*
Plugin Name: Blog in Blog
Plugin URI: http://informationtakesover.co.uk/blog-in-blog-wordpress-plugin/
Description: Create a blog within a blog using a category. This plugin basically shows posts in a category on a page using shortcodes.
Version: 0.9
Author: Tim Hodson
Author URI: http://timhodson.com
Text Domain: blog-in-blog
*/
/*  Copyright 2009  Tim Hodson  (email : tim@timhodson.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
* [blog_in_blog category_id= num= template='']
* Assume most recent first (it's supposed to be a mini blog)
*/

global $blog_in_blog_opts;

$plugin_dir = basename(dirname(__FILE__));
load_plugin_textdomain( 'blog-in-blog', 'wp-content/plugins/' . $plugin_dir, $plugin_dir );


function bib_get_opts() {
	global $blog_in_blog_opts;

	$blog_in_blog_opts['display_dots_after'] = get_option('bib_show_dots_after');
	if ($blog_in_blog_opts['display_dots_after'] == '') {
		$blog_in_blog_opts['display_dots_after'] = 5;

		update_option('bib_show_dots_after', $blog_in_blog_opts['display_dots_after']);
	}

	$blog_in_blog_opts['delimiter'] = get_option('bib_text_delim');
	if ($blog_in_blog_opts['delimiter'] == '') {
		$blog_in_blog_opts['delimiter'] = ",";

		update_option('bib_text_delim', $blog_in_blog_opts['delimiter']);
	}

	$blog_in_blog_opts['page_text'] = get_option('bib_text_page');
	if ($blog_in_blog_opts['page_text'] == '') {
		$blog_in_blog_opts['page_text'] = __('Page', 'blog-in-blog');

		update_option('bib_text_page', $blog_in_blog_opts['page_text']);
	}

	$blog_in_blog_opts['prev_link_text'] = get_option('bib_text_previous');
	if ($blog_in_blog_opts['prev_link_text'] == '') {
		$blog_in_blog_opts['prev_link_text'] = '&laquo;';

		update_option('bib_text_previous', $blog_in_blog_opts['prev_link_text']);
	}

	$blog_in_blog_opts['next_link_text'] = get_option('bib_text_next');
	if ($blog_in_blog_opts['next_link_text'] == '') {
		$blog_in_blog_opts['next_link_text'] = '&raquo;';

		update_option('bib_text_next', $blog_in_blog_opts['next_link_text']);
	}
	$blog_in_blog_opts['style_selected'] = get_option('bib_style_selected');
	if ($blog_in_blog_opts['style_selected'] == '') {
		$blog_in_blog_opts['style_selected'] = 'font-weight:bold;';

		update_option('bib_style_selected', $blog_in_blog_opts['style_selected']);
	}
	$blog_in_blog_opts['style_not_selected'] = get_option('bib_style_not_selected');
	if ($blog_in_blog_opts['style_not_selected'] == '') {
		$blog_in_blog_opts['style_not_selected'] = 'color:grey;';

		update_option('bib_style_not_selected', $blog_in_blog_opts['style_not_selected']);
	}
	$blog_in_blog_opts['post_template'] = get_option('bib_post_template');
	if ($blog_in_blog_opts['post_template'] == '') {
		$blog_in_blog_opts['post_template'] = 'bib_post_template.tpl';

		update_option('bib_post_template', $blog_in_blog_opts['post_template']);
	}
	$blog_in_blog_opts['more_link_text'] = get_option('bib_more_link_text');
	if ($blog_in_blog_opts['more_link_text'] == '') {
		$blog_in_blog_opts['more_link_text'] = __('more', 'blog-in-blog').' &raquo;';

		update_option('bib_more_link_text', $blog_in_blog_opts['more_link_text']);
	}

	$blog_in_blog_opts['date_format'] = get_option('bib_date_format');
	if ($blog_in_blog_opts['date_format'] == '') {
		$blog_in_blog_opts['date_format'] = '%A %d %B, %Y';

//		$df = get_option(date_format);
//		$dt = get_option(time_format);
//
//		$blog_in_blog_opts['date_format'] =
		update_option('bib_date_format', $blog_in_blog_opts['date_format']);
	}


	$blog_in_blog_opts['avatar_size'] = get_option('bib_avatar_size');
	if ($blog_in_blog_opts['avatar_size'] == '') {
		$blog_in_blog_opts['avatar_size'] = 96;

		update_option('bib_avatar_size', $blog_in_blog_opts['avatar_size']);
	}
	
	//bib_hide_category_from_rss
	$blog_in_blog_opts['bib_hide_category_from_rss'] = get_option('bib_hide_category_from_rss');
	if ($blog_in_blog_opts['bib_hide_category_from_rss'] == '') {
		$blog_in_blog_opts['bib_hide_category_from_rss'] = 0;

		update_option('bib_hide_category_from_rss', $blog_in_blog_opts['bib_hide_category_from_rss']);
	}

}

/**
 * call bib_get_opts here to get default options set
 *  even if not using the plugin right away.
 * Makes sure that this is uptodate for the admin page
 *
 */
bib_get_opts();

function blog_in_blog_func($atts) {
	global $blog_in_blog_opts;
	global $wp_query;

	extract(shortcode_atts(array (
	'category_id' => '1',
	'num' => '10',
	'template' => $blog_in_blog_opts['post_template'],
	'pagination' => 'on'
	), $atts));

	$blog_in_blog_opts['cat'] = $category_id;
	$blog_in_blog_opts['num'] = $num;
	
	if ( file_exists( WP_CONTENT_DIR . '/uploads/' . $template ) ) {
		$blog_in_blog_opts['post_template'] = WP_CONTENT_DIR . '/uploads/' . $template;
	}else{
		$blog_in_blog_opts['post_template'] = WP_PLUGIN_DIR . "/blog-in-blog/" . 'bib_post_template.tpl';
	}
	// get some posts for that category
	$out = "";

	$blog_in_blog_opts['offset'] = $wp_query->query['offset'];
	//	var_dump($wp_query->query);
	//	echo "offset : $nextoffset";

	$params = array (
	'numberposts' => $num,
	'orderby' => 'date',
	'order' => 'DESC',
	'offset' => $blog_in_blog_opts['offset'],
	'category' => $category_id
	);

	$postslist = get_posts($params);
	//	$postslist = get_posts(array_merge($params, $wp_query->query));
	foreach ($postslist as $post) {

		//var_dump($post);
		// could format the datetime too.
		$data['post_id'] = $post->ID;

		$data['post_date'] = strftime($blog_in_blog_opts['date_format'], strtotime($post->post_date_gmt));
		$data['post_day'] = strftime('%d', strtotime($post->post_date_gmt));
		$data['post_dw'] = strftime('%a', strtotime($post->post_date_gmt));
		$data['post_dow'] = strftime('%A', strtotime($post->post_date_gmt));
		$data['post_mon'] = strftime('%b', strtotime($post->post_date_gmt));
		$data['post_month'] = strftime('%B', strtotime($post->post_date_gmt));
		$data['post_year'] = strftime('%Y', strtotime($post->post_date_gmt));
		$data['post_yr'] = strftime('%y', strtotime($post->post_date_gmt));

		$data['post_title'] = $post->post_title;

		$user = get_userdata( $post->post_author );
		$data['post_author'] = $user->display_name;
		//var_dump($data['post_author']);
		$data['post_author_avatar'] = get_avatar( $post->post_author , $blog_in_blog_opts['avatar_size'] );

		$data['post_content'] = apply_filters('the_content', $post->post_content);
		$data['post_permalink'] = apply_filters('the_permalink', get_permalink($post));
		$data['post_comments'] = bib_process_comments($post->comment_status, $post->comment_count, $data['post_permalink']);

		$cats = get_the_category($post->ID);
		$catstr="";
		foreach ($cats as $v)
		{
			$cat_link = get_category_link( $v->cat_ID);
			$catstr .= ' <a href="'.$cat_link.'" title="'.$v->cat_name.'" >'.$v->cat_name.'</a>'.$blog_in_blog_opts['delimiter'];

		}
		$catstr = substr($catstr, 0, strlen($catstr) - strlen($blog_in_blog_opts['delimiter']));
		$data['post_categories'] = $catstr;

		$data = bib_process_moretag($data);

		$out .= bib_parse_template($data);
	}

	if($pagination == 'on'){
		$out .= blog_in_blog_page_navi();
		// func - get page navi

	}

	// return the posts data.
	return $out;
}
add_shortcode('blog_in_blog', 'blog_in_blog_func');

/**
 * parse template string
 */
function bib_parse_template($data) {
	global $blog_in_blog_opts;

	// get template string from options
	if( file_exists( $blog_in_blog_opts['post_template'] ) ) {
		$template = file_get_contents( $blog_in_blog_opts['post_template'] );
		$template = str_replace("%post_id%", $data['post_id'], $template);
		
		$template = str_replace("%post_date%", $data['post_date'], $template);
        $template = str_replace("%post_day%", $data['post_day'], $template);
        $template = str_replace("%post_dw%", $data['post_dw'], $template);
        $template = str_replace("%post_dow%", $data['post_dow'], $template);
        $template = str_replace("%post_mon%", $data['post_mon'], $template);
        $template = str_replace("%post_month%", $data['post_month'], $template);
        $template = str_replace("%post_year%", $data['post_year'], $template);
        $template = str_replace("%post_yr%", $data['post_yr'], $template);
		$template = str_replace("%post_title%", $data['post_title'], $template);

		$template = str_replace("%post_author%", $data['post_author'], $template);
		$template = str_replace("%post_author_avatar%", $data['post_author_avatar'], $template);

		$template = str_replace("%post_content%", $data['post_content'], $template);
		$template = str_replace("%post_permalink%", $data['post_permalink'], $template);
		$template = str_replace("%post_categories%", $data['post_categories'], $template);
		$template = str_replace("%post_comments%", $data['post_comments'], $template);
	}
	else
	{

		$template="<p>[blog_in_blog] Can't read the template file: $filename</p>";
	}


	return $template;
}

/**
 * Process comment data and build a string
 */
function bib_process_comments($cStatus, $cCount, $permalink){

	if ( ( $cStatus == 'open' && $cCount > 0 ) || ( $cStatus == 'closed' && $cCount > 0 ) ) {

		$out= '<a href="'.$permalink.'#comments" title="'.__('Comments','blog-in-blog').'" >'
		. sprintf( __ngettext('%d Comment', '%d Comments', $cCount , 'blog-in-blog').' &raquo;', $cCount).'</a>';

	}
	elseif ($cStatus == 'open'){

		$out= '<a href="'.$permalink.'#respond" title="'.__('Respond', 'blog-in-blog').'" >'
		. __('Leave a response ', 'blog-in-blog').'&raquo;</a>';

	}
	elseif($cStatus == 'closed'){

		$out .= __('Comments are closed', 'blog-in-blog');

	}


	return $out;
}

/**
 * based on get_the_content() in wp-includes/post-template.php
 */
function bib_process_moretag($data) {
	global $blog_in_blog_opts;
	global $more, $multipage, $page;
	$more = 0;

	$output = '';
	$hasTeaser = false;
	$more_link_text = $blog_in_blog_opts['more_link_text'];

	if (preg_match('/<!--more(.*?)?-->/', $data['post_content'], $matches)) {
		$content = explode($matches[0], $data['post_content'], 2);
		if (!empty ($matches[1]) && !empty ($more_link_text))
		$more_link_text = strip_tags(wp_kses_no_null(trim($matches[1])));

		$hasTeaser = true;
		//$more = 0;

	} else {
		$content = array (
		$data['post_content']
		);
		// $more = 1;
	}

	if ((false !== strpos($data['post_content'], '<!--noteaser-->')) && ((!$multipage) || ($page == 1))) {
		$stripteaser = 1;

	}
	$teaser = $content[0];

	if (($more) && ($stripteaser) && ($hasTeaser)){
		//    if ( ($more) && ($hasTeaser) )

		$teaser = '';

	}

	$output .= $teaser;

	if (count($content) > 1) {
		if ($more) {

			$output .= '<span id="more-' . $data['post_id'] . '"></span>' . $content[1];
		} else {

			if (!empty ($more_link_text))
			$output .= apply_filters('the_content_more_link', ' <a href="' . $data['post_permalink'] . "#more-{$data['post_id']}'\" class=\"more-link\">$more_link_text</a>", $more_link_text);
			$output = force_balance_tags($output);
		}

	}

	$data['post_content'] = $output;
	return $data;

}

/**
 * Func to get permalink and make sure there is a ? ready for params.
 */
function bib_get_permalink() {

	// check for existing /?.*=.*/
	//if not found add ? to end of url
	$perma_link = get_permalink();
	if (preg_match('/\?.*\=.*/', $perma_link)){
			echo "match URL";
			return $perma_link;
	}
	else
	{
		$perma_link = $perma_link."?";
		return $perma_link;
	}
}

/**
 * Page navi
 */
function blog_in_blog_page_navi() {
	global $blog_in_blog_opts;

	// count pages in chosen category
	$catposts = bib_get_post_count();
	$num = $blog_in_blog_opts['num'];

	$dlimit = $blog_in_blog_opts['display_dots_after'];
	$elipsis = " ...";
	$page = 0;
	$maxpages = floor($catposts / $num);
	$nextoffset = 0;

	$out = '<div style="bib_page_nav">';

	// show page jumps for every $n posts
	for ($i = 0; $i < $catposts; $i++) {
		if ($i % $num == 0) {
			// start a new page, so
			$nextpage = $page++;
			$nextoffset = $thisloop;
			$thisloop++;
			if ($i +1 == $catposts) {
				$lastpage = true;
			}

			// check if this is the current page (based on offset, if offset not set is first page selected
			if ($match == false && (!isset ($blog_in_blog_opts['offset']) || $thisloop -1 == $blog_in_blog_opts['offset'])) {
				//				$selected = ' bib_selected" style="font-weight:bold;color:red;';
				$selected = ' bib_selected" style="' . $blog_in_blog_opts['style_selected'] . '"';

				$poffset = ($nextoffset - $num);
				$noffset = ($nextoffset + $num);
				$prevlink = ($nextoffset > 0) ? '<a href="' . bib_get_permalink() . '&offset=' . $poffset . '">' . $blog_in_blog_opts['prev_link_text'] . '</a> ' : $blog_in_blog_opts['prev_link_text'] . ' ';
				$nextlink = ($noffset < $catposts) ? ' <a href="' . bib_get_permalink() . '&offset=' . $noffset . '">' . $blog_in_blog_opts['next_link_text'] . '</a>' : ' ' . $blog_in_blog_opts['next_link_text'];

				$pages[$page]['current'] = true;
				$match = true;
			} else {
				$selected = ' bib_not_selected" style="' . $blog_in_blog_opts['style_not_selected'] . '"';
			}

			// if first page has been output
			if ($first == false) {
				$pout = $blog_in_blog_opts['page_text'] . ' <a href="' . get_permalink() . '" class="bib_page_number' . $selected . '" > ' . $page . '</a>' . $blog_in_blog_opts['delimiter'];
				$pages[$page]['html'] = $pout;
				$first = true;
			} else {
				// only output delimiter and page numbers
				if ($lastpage) {
					$pout = ' <a href="' . bib_get_permalink() . '&offset=' . $nextoffset . '" class="bib_page_number' . $selected . '" >' . $page . '</a>';

				} else {
					$pout = ' <a href="' . bib_get_permalink() . '&offset=' . $nextoffset . '" class="bib_page_number' . $selected . '" >' . $page . '</a>' . $blog_in_blog_opts['delimiter'];
				}
				$pages[$page]['html'] = $pout;
			}
		} else {
			$nextpage = $page;
			$thisloop++;
		}

		//echo "<br />$i, nextpage: $nextpage, thisloop: $thisloop, page: $page, nextoffset: $nextoffset, URLoffset: {$blog_in_blog_opts['offset']}";

		if ($thisloop == $nextpage) {
			// do what exactly?

		}

	}
	//	var_dump($pages);

	if (count($pages) > $dlimit) {
		$max = count($pages);

		$fp = $pages[1]['html'];
		$lp = $pages[$max]['html'];

		foreach ($pages as $k => $page) {
			if ($page['current']) {

				if ($k == 1 || $k == 2 || $k == 3) {
					$fp = '';
					$elipsisa = '';
				}
				elseif ($k == 4) {
					$elipsisa = $blog_in_blog_opts['delimiter'];
				} else {

					$elipsisa = $elipsis;
				}

				$precurr = $pages[$k -2]['html'];
				$precurr .= $pages[$k -1]['html'];
				$current = $pages[$k]['html'];
				$postcurr = $pages[$k +1]['html'];
				//				 trim delimiter from end of string.
				$postcurr .= substr($pages[$k +2]['html'], 0, strlen($pages[$k +2]['html']) - strlen($blog_in_blog_opts['delimiter']));

				if ($k == $max || $k == ($max -1) || $k == ($max -2)) {
					$lp = '';
					$elipsisb = '';
				}
				elseif ($k == ($max -3)) {
					$elipsisb = $blog_in_blog_opts['delimiter'];
				} else {

					$elipsisb = $elipsis;
				}
			}
		}

		$out .= $prevlink . $fp . $elipsisa . $precurr . $current . $postcurr . $elipsisb . $lp . $nextlink;
	} else {
		if (is_array($pages)) {
			foreach ($pages as $page) {
				$pagesout .= $page['html'];
			}
		}
		// remove trailing delimiter
		$pagesout = substr($pagesout, 0, strlen($pagesout) - strlen($blog_in_blog_opts['delimiter']));

		$out .= $prevlink . $pagesout . $nextlink;
	}

	$out .= '</div>';
	//	echo htmlspecialchars($out);
	// return HTML
	return $out;

}

function bib_get_post_count() {
	global $wpdb;
	global $blog_in_blog_opts;
	$post_count = 0;
	$categories = $blog_in_blog_opts['cat'];

	$querystr = "
				SELECT count
				FROM $wpdb->term_taxonomy, $wpdb->posts, $wpdb->term_relationships
				WHERE $wpdb->posts.ID = $wpdb->term_relationships.object_id
				AND $wpdb->term_relationships.term_taxonomy_id = $wpdb->term_taxonomy.term_taxonomy_id
				AND $wpdb->term_taxonomy.term_id = $categories
				AND $wpdb->posts.post_status = 'publish'
			";
	//	echo $querystr;
	$result = $wpdb->get_var($querystr);
	//	echo $result;
	$post_count = $result;
	return $post_count;
}

add_filter('query_vars', 'bib_url_params');
function bib_url_params($qvars) {
	$qvars[] = 'offset';
	return $qvars;
}

/*
* Hide the category chosen to be the blog
*/

add_action('pre_get_posts', 'bib_hide_category');

function bib_hide_category($notused) {
	global $wp_query;

	$cat = get_option('bib_hide_category');
	if ( is_home() ) {
		//var_dump($cat);
		if (is_array($cat)) {

			foreach ($cat as $v) {

				if($v != "NONE"){
					$c .= '-' . $v . ',';
				}

			}
			$wp_query->query_vars['cat'] = $c;
		}
	}

}

function bib_hide_category_feed($query) {

	if (get_option('bib_hide_category_from_rss'))
	{
		if ($query->is_feed) {
			$cat = get_option('bib_hide_category');
			if (is_array($cat)) {
				foreach ($cat as $v){
					if($v != "NONE"){
						$c .= '-' . $v . ',';
					}
				}
			
				$query->set('cat', $c);
			}
		}
    }
    return $query;
}

add_filter('pre_get_posts','bib_hide_category_feed');

// alternative way to hide categories directly in the template page
// if (is_home()) {
//  query_posts("cat=-8");
//}

/**
 * =========================================================
 * Add options to admin menu
 */

add_option('bib_hide_category');

add_action('admin_menu', 'blog_in_blog_menu');

function blog_in_blog_menu() {
	add_options_page('blog in blog Options', 'Blog-in-Blog', 8, __FILE__, 'blog_in_blog_options');
}

function blog_in_blog_options() {
	$out = "";
	$out .= '<div class="wrap">';
	$out .= '<h2>Blog-in-Blog</h2>';
	$out .= '<p>'.__('See full notes at', 'blog-in-blog'). ' <a href="http://informationtakesover.co.uk/blog-in-blog-wordpress-plugin/">http://informationtakesover.co.uk/blog-in-blog-wordpress-plugin/</a></p>';

	$out .= '<form method="post" action="options.php">';
	$out .= wp_nonce_field('update-options');
	$out .= '<style type="text/css">.form-table td {width:80px;}</style>';
	$out .= '<table class="form-table">';

	// categories to hide
	$out .= '<tr valign="top" ><th scope="row">'.__('Category id to hide from homepage','blog-in-blog').'</th><td>';
	$select = '<select name="bib_hide_category[]" multiple="multiple" size="6" style="height:auto;">';

	$catselected = get_option('bib_hide_category');
	if (!is_array($catselected)) {
		$catselected = array($catselected);
	}
	//var_dump($catselected);

	$categories = get_categories();

	if (is_array($categories)) {

		foreach ($categories as $cat) {

			if (in_array($cat->cat_ID, $catselected)) {
				$select .= '<option value="' . $cat->cat_ID . '" selected="selected" >';
				$select .= $cat->cat_name . ' (category_id:' . $cat->cat_ID;
				$select .= ', ' . $cat->category_count . ' posts)';
				$select .= '</option>';

			} else {
				$select .= '<option value="' . $cat->cat_ID . '">';
				$select .= $cat->cat_name . ' (category_id:' . $cat->cat_ID;
				$select .= ', ' . $cat->category_count . ' posts)';
				$select .= '</option>';
			}

		}
	}
	$select .= '<option value="NONE">'.__('Show all categories', 'blog-in-blog').'</option>';
	$select .= '</select>';
	$out .= $select . '</td></tr>';

	// hide categories from RSS feed
	if (get_option('bib_hide_category_from_rss')) {
		$checked = 'checked="checked""';
	}else{
		$checked = '';
	}
	$out .= '<tr valign="top"><th scope="row">'.__('Hide categories from feed?', 'blog-in-blog').'</th><td><input type="checkbox" name="bib_hide_category_from_rss" '.$checked.' /></td></tr>';
	
	
	// show dots after n pages
	$out .= '<tr valign="top"><th scope="row">'.__('Show dots (elipsis) after n pages', 'blog-in-blog').'</th><td><input type="text" name="bib_show_dots_after" value="' . get_option('bib_show_dots_after') . '" /></td></tr>';

	// previous link text
	$out .= '<tr valign="top"><th scope="row">'.__('Text to show as "previous page" link', 'blog-in-blog').'</th><td><input type="text" name="bib_text_previous" value="' . get_option('bib_text_previous') . '" /></td></tr>';

	// next link text
	$out .= '<tr valign="top"><th scope="row">'.__('Text to show as "next page" link', 'blog-in-blog').'</th><td><input type="text" name="bib_text_next" value="' . get_option('bib_text_next') . '" /></td></tr>';

	// text preceeding page 1
	$out .= '<tr valign="top"><th scope="row">'.__('Text to show preceeding page 1. e.g. Post (Post 1, 2, 3) or Page (Page 1, 2, 3) etc', 'blog-in-blog').'</th><td><input type="text" name="bib_text_page" value="' . get_option('bib_text_page') . '" /></td></tr>';

	// delimiter
	$out .= '<tr valign="top"><th scope="row">'.__('The characters to show between page links, e.g. "," or "|"', 'blog-in-blog').'</th><td><input type="text" name="bib_text_delim" value="' . get_option('bib_text_delim') . '" /></td></tr>';

	// Style selected
	$out .= '<tr valign="top"><th scope="row">'.__('Style for current page e.g. font-weight:bold;', 'blog-in-blog').'</th><td><input type="text" name="bib_style_selected" value="' . get_option('bib_style_selected') . '" /></td></tr>';
	
	// Style not selected
	$out .= '<tr valign="top"><th scope="row">'.__('Style for non current page e.g. color:grey;', 'blog-in-blog').'</th><td><input type="text" name="bib_style_not_selected" value="' . get_option('bib_style_not_selected') . '" /></td></tr>';
	
	// template file
	if( ( get_option('bib_post_template') == 'bib_post_template.tpl' ) && (! file_exists(WP_CONTENT_DIR . '/uploads/'.get_option('bib_post_template')))) {
		$template_warn_title= __('You are using the default template file', 'blog-in-blog');
		$template_warn_body= __('Any changes you make may be overwritten when a new version of the plugin is installed. You are advised to put your template file in the uploads directory. We\'ll look here first. e.g. wp-content/uploads/my_post_template.tpl', 'blog-in-blog');
		$template_warn = '<div><span style="color:red;font-weight:bold;">'.$template_warn_title.'</span> <br />'.$template_warn_body.'</div>';
	}else{
		$template_warn = "";
	}
	$out .= '<tr valign="top"><th scope="row">'.__('The name of the template used to style the post. We look in wp-content/uploads/ then wp-content/plugins/blog-in-blog/ for this file. '.$template_warn, 'blog-in-blog').'</th><td><input type="text" name="bib_post_template" value="' . get_option('bib_post_template') . '" /></td></tr>';

	// more_link_text
	$out .= '<tr valign="top"><th scope="row">'.__('Text for the more link if you use the &lt;!--more--&gt; tag in your posts.', 'blog-in-blog').'</th><td><input type="text" name="bib_more_link_text" value="' . get_option('bib_more_link_text') . '" /></td></tr>';

	// avatar image size
	$out .= '<tr valign="top"><th scope="row">'.__('Size of the author avatar image', 'blog-in-blog').'</th><td><input type="text" name="bib_avatar_size" value="' . get_option('bib_avatar_size') . '" /></td></tr>';

	$out .= '</table>';

	$out .= '<input type="hidden" name="action" value="update" />';
	$out .= '<input type="hidden" name="page_options" value="bib_hide_category,bib_show_dots_after,bib_text_previous,bib_text_next,bib_text_page,bib_text_delim,bib_post_template,bib_style_selected,bib_style_not_selected,bib_more_link_text,bib_avatar_size,bib_hide_category_from_rss" />';

	$out .= '<p class="submit">';
	$out .= '<input type="submit" class="button-primary" value="'.__('Save Changes', 'blog-in-blog').'" />';
	$out .= '</p>';

	$out .= '</form>';
	$out .= '</div>';

	echo $out;
}
?>
